(**********************************************************************
*                                                                     *
*       ஢  ⥪⮢ 䠩  ⮢ ⮪      *
*                                                                     *
**********************************************************************)
{$O-}
{$I Include.pas}
                             unit  Demo_Un1;
                               interface

uses  Objects, Drivers, Views, Menus, TextView, Dialogs, App,
      MsgBox, StdDlg,
      Figaro, FigaroDG, FigaroIO, WinProcs, Commands;
{}
type

  PProcessTextCopy = ^TProcessTextCopy;
  TProcessTextCopy = object(TProcessTerm)
     _Input, _Output : ^Text;
     procedure Stop;    virtual;
     procedure Restart; virtual;
     procedure Delete;  virtual;
  end;

  PProcessStreamCopy = ^TProcessStreamCopy;
  TProcessStreamCopy = object(TProcess)
     _Input, _Output : PDosStream;
     procedure Stop;    virtual;
     procedure Restart; virtual;
     procedure Delete;  virtual;
  end;

  PProgress = ^TProgress;
  TProgress = object (TDialog)
          _total, _curr   : longint;
          _step , _sum    : longint;
          _line1, _line2  : PStaticText;
          _Process        : String;
        constructor Init (const Header : string;
                                Total  : longint;
                         const Process : String);
        destructor  Done ; virtual;
        procedure   HandleEvent (var E : TEvent); virtual;
        procedure   Increment (delta : integer);
        procedure   Reset (const Name : string; Total: longint);
        function    GetLine1 : string;
   end;

procedure MakeTextCopy;
procedure MakeStreamCopy;
{}
                             implementation
{}
const  CStackText   = 4000;
       CStackStream = 6000;

{
       ķ
                              TProcessTextCopy                  
       Ľ
}
procedure TProcessTextCopy.Stop   ;
begin
  if Get_MyPtr <> nil
     then begin
           if Assigned(_Input)  then InProcess_Close(_Input^);
           if Assigned(_Output) then InProcess_Close(_Output^);
          end
     else begin
           asm
              PUSHF
              CLI
           end;
           if Assigned(_Input)  then System.Close(_Input^);
           if Assigned(_Output) then System.Close(_Output^);
           asm  POPF  end;
          end;
  _Input:=nil;  _Output:=nil;
  inherited Stop;
end;

procedure TProcessTextCopy.Restart;
begin
end;


procedure TProcessTextCopy.Delete;
begin
  Stop;
  inherited Delete
end;


procedure Process_TextCopy;
var F_IN, F_OUT : Text;
    res : word;
    s   : string;
    R   : TRect;
    W   : PWinTerminal;
    P   : PProcessTextCopy;
    MyPriory : integer;

procedure LocalError (const s: string);
begin
   W^.Writeln(s);
   InProcess_MessageBox( ^C+Get_MyName+^M^C+s, mfError + mfOkButton);
   Delete_Process('');
end;

begin
  MyPriory := Get_Priory('');
  StartPause;
  W:= PWinTerminal(Get_MyParamPtr);
  if not Assigned(W) then  Delete_Process('');
  P:= PProcessTextCopy(Get_MyPtr);
  with P^ do  begin _Input:=nil; _Output:=nil end;

  s:='*.*';
  res:=InProcess_FileDialog(@s, Get_MyName, 'Enter input text file',
                                fdOpenButton, 1);
  if res = cmCancel then LocalError ('Input file not selected');
  Assign (F_IN,  s);

  s:='NUL';
  res:=InProcess_FileDialog(@s, Get_MyName, 'Enter output file name',
                                fdOpenButton, 1);
  if res = cmCancel then LocalError ('Output file not selected');
  Assign (F_OUT,  s);

  repeat
    res:=InProcess_Rewrite(F_OUT);
    if res <> OK then begin
       Str (res, s);
       LocalError('Rewrite error : '+s);
    end;
    P^._Output:=@F_OUT;
    res:=InProcess_Reset(F_IN);
    if res <> OK then begin
       Str (res, s);
       LocalError('Reset error : '+s);
    end;
    P^._Input:=@F_IN;
    while not eof(F_IN) do begin
       res:=InProcess_Readln(F_IN, @s);
       if res <> OK then LocalError('Readln error');
       res:=InProcess_Writeln(F_OUT, @s);
       if res <> OK then LocalError('Writeln error');
       W^.Writeln(s);
    end;
    res:=InProcess_Close(F_IN);
    if res <> OK then LocalError('Close error');
    Set_Priory('', MyPriory);
    Pause(CSecond);
  until false;
end;

procedure MakeTextCopy;
const
   count : word = 0;
   R     : TRect= (A:(X: 0; Y: 0); B:(X: 38; Y: 10));
var     s : string;
begin
  Inc (count);  R.Move(2,2);
  Str (count, s);
  s:='Text copy # ' + s;
  Disable_Interrupt;
  Application^.InsertWindow (New(PWinTerminal,
       Init(R, s,
       New(PProcessTextCopy,
       Init(s, true, 210,  MaxInt,  8, Stack(CStackText),
            @Process_TextCopy, nil)))));
  Enable_Interrupt;
end;
{
       ķ
                            TProcessStreamCopy                  
       Ľ
}
procedure TProcessStreamCopy.Stop;
begin
  if Get_MyPtr <> nil
     then begin
       if Assigned(_Input)  then  InProcess_StreamClose (@_Input);
       if Assigned(_Output) then  InProcess_StreamClose (@_Output);
     end
     else begin
       asm
          PUSHF
          CLI
       end;
       if Assigned(_Input)  then  Dispose(_Input, Done);
       if Assigned(_Output) then  Dispose(_Output,Done);
       _Input:=nil;  _Output:=nil;
       asm  POPF  end;
     end;
  inherited Stop;
end;

procedure TProcessStreamCopy.Restart;
begin
end;

procedure TProcessStreamCopy.Delete;
begin
  Stop;
  inherited Delete;
end;

procedure Process_StreamCopy;
const  CBuf= 512;
var
    Process  : PProcessStreamCopy;
    Progress : PProgress;
    MyPriory : integer;
    res      : longint;
    MyName, NameInp, NameOut: string;
    Buf : array [0..CBuf-1] of byte;

procedure LocalError (const s: string);
begin
   InProcess_MessageBox( ^C+Get_MyName+^M^C+s, mfError + mfOkButton);
   Delete_Process('');
end;

function  LocalOpen : word;
begin

with Process^ do begin
  InProcess_StreamInit (@Process^._Input, NameInp, stOpen, 2*CBuf);
  if _Input = nil          then  LocalError ('StreamInp init error');
  if _Input^.Status<>stOK  then  LocalError ('StreamInp init error');

  InProcess_StreamInit (@Process^._Output, NameOut, stCreate, 2*CBuf);
  if _Output = nil          then  LocalError ('StreamOut init error');
  if _Output^.Status<>stOK  then  LocalError ('StreamOut init error');
end;
end;

function  LocalClose : word;
begin
     with Process^ do begin
       InProcess_StreamClose (@_Input);
       InProcess_StreamClose (@_Output);
     end;
end;
begin
  MyPriory := Get_Priory('');
  StartPause;
  Progress:= PProgress (Get_MyParamPtr);
  if not Assigned(Progress) then Delete_Process('');
  MyName:=Get_MyName;
  Process:= PProcessStreamCopy(Get_MyPtr);
  with Process^ do  begin _Input:=nil; _Output:=nil end;

  NameInp:='*.*';
  res:=InProcess_FileDialog(@NameInp, Get_MyName,
                   'Enter input stream file:', fdOpenButton, 1);
  if res = cmCancel then LocalError ('Stream file not selected');

  NameOut:='NUL';
  res:=InProcess_FileDialog(@NameOut, Get_MyName,
                      'Enter output stream', fdOpenButton, 1);
  if res = cmCancel then LocalError ('Output stream not selected');

  repeat
    LocalOpen;
    Progress^.Reset(NameInp, Process^._Input^.GetSize);
    with Process^ do while _Input^.Status=stOK do begin
       InProcess_StreamRead (_Input,  @BUF, sizeof(BUF));
       InProcess_StreamWrite(_Output, @BUF, sizeof(BUF));
       if _Output^.Status<>stOK  then
             LocalError ('StreamOut write error');
       Progress^.Increment(SizeOf(Buf));
    end;
    LocalClose;
    Pause(CSecond div 2);
    Set_Priory('', MyPriory);
  until false;
end;
{}
procedure MakeStreamCopy;
const
   count : word = 0;
var S : string;
    P : PProcessStreamCopy;
    W : PProgress;
begin
   Inc (count);
   Str (count, s);
   s:='Stream copy # '+s;
   Disable_Interrupt;
      p:= New(PProcessStreamCopy,
           Init(s, true, 210,  MaxInt,  4, Stack(CStackStream),
                @Process_StreamCopy, nil));
      if Assigned(p) then
         begin
           W:= New(PProgress, Init(s, 1, s));
           P^._ParamPtr:=W;
           if Application^.InsertWindow (W)<>nil
              then  Insert_Process (p)
              else  Dispose (p, Done);
         end;
   Enable_Interrupt;
end;
{
       ķ
                                TProgress                       
       Ľ
}
const    CPrgLen   = 40;       {  ப ண }

constructor TProgress.Init (const Header : string;
                                  Total  : longint;
                            const Process: String);
var
   R : TRect;   P: PView;
begin
   R.Assign (0,0,CPrgLen+6,8);
   R.Move (1+Random(20), 1+Random(10));
   if not inherited Init (R, Header) then Fail;
   Flags:= Flags and not wfClose;
   _process:= Process;
   _curr   := 0;
   _total  := Total;
   _step   := Total div CPrgLen;
    if _step = 0  then  _step:= 1;
   _sum    := 0;

   GetExtent (R);  R.Grow(-1,-1); R.B.Y:=R.A.Y+1;
   _line2 :=New (PStaticText, Init (R, ''));
   with _line2^ do Options:= Options or ofCenterX;
   Insert (_line2);

   R.Assign (0,3,CPrgLen,4);
   New (_line1, Init (R, GetLine1));
   with _line1^ do Options:= Options or ofCenterX;
   Insert (_line1);

   R.Assign (CPrgLen div 3 - 9, 5, CPrgLen div 3 + 2, 7);
   Insert (New(PButton, Init(R,'~L~ock', cmLock, 0)));

   R.Assign (0, 5, 10, 7);
   P:= New(PButton, Init(R, '~U~nlock', cmUnlock, 0));
   with P^ do Options:= Options or ofCenterX;
   Insert(P);

   R.Assign ((2*CPrgLen) div 3 + 5, 5, (2*CPrgLen) div 3 + 15, 7);
   Insert (New(PButton, Init(R,'~D~elete', cmDelete, 0)));

   SelectNext(false);
end;

destructor TProgress.Done;
begin
  Delete_Process(_Process);
  inherited Done;
end;

procedure   TProgress.HandleEvent (var E : TEvent);
begin
  inherited  HandleEvent(E);
  with E do if What=evCommand then
    case Command of
      cmLock    : Lock_Process(_Process);
      cmUnlock  : Unlock_Process(_Process);
      cmSuspend : Suspend_Process(_Process, CSecond*15);
      cmResume  : Resume_Process(_Process);
      cmDelete  : Close;
      else exit
    end;
  ClearEvent(E);
end;

function TProgress.GetLine1 : string;
var S : string[63];
    i : integer;
    x : longint;
begin
     S:='';
     for i:=1 to CPrgLen do System.Insert (#176, S, 1);
     x:= longint(CPrgLen+1)  * _curr;
     x:= x div _total;
     for i:=1 to x do  S[i]:=#219;
     GetLine1:= S;
end;

procedure TProgress.Increment (delta : integer);
begin
     Inc (_curr, delta);
     Inc (_sum, delta);
     if (_sum < _step) and (delta <> 0) then exit;
     _sum:=0;
     if _curr > _total then _curr:= _total;
     _Line1^.Text^:=GetLine1;
     _Line1^.DrawView;
end;

procedure   TProgress.Reset (const Name : string; Total: longint);
begin
   _curr   := 0;
   _total  := Total;
   if not Assigned(_Line2^.Text)
      then begin
           _Line2^.Text:= NewStr (^C+Name);
           _Line2^.DrawView;
           end;
   Increment(0);
end;

end.
