(**********************************************************************
*                                                                     *
*          ꥪ 筮 ਫ Turbo-Vision      *
*                                                                     *
**********************************************************************)
{$O-}
{$I Include.pas}
                             unit  FigaroTV;
                               interface

uses  Objects, Drivers, Views, Menus, TextView, Dialogs, MsgBox,
      App, Figaro;

const

  evIO          = evBroadcast shl 2;     {  -뢮 }
  evDialog      = evIO shl 2;            {   }
  CMinPriory    = 100;                   { 訩 ਮ }
  CNameKeyboard ='...Keyboard';          {  ⠭ ᮢ }
  CNameMouse    ='...Mouse';

type

  PEventsQue = ^TEventsQue;
  TEventsQue = object (TCollection)
    constructor Init (Size : integer);
    procedure   FreeItem(p: pointer); virtual;
    procedure   PutEvent (var E : TEvent);
    procedure   GetEvent (var E : TEvent);
  end;

  PAppFigaro = ^TAppFigaro;
  TAppFigaro = object(TApplication)
        _StartDialog: boolean;
        _QuePtr     : PEventsQue;
        _EvDialog   : Boolean;
        _Regime     : word;
        _Freq       : word;
     constructor Init ;
     destructor  Done; virtual;
     procedure   PutEvent   (var E : TEvent); virtual;
     procedure   GetEvent   (var E : TEvent); virtual;
     procedure   HandleIO   (var E: TEvent);  virtual;
     procedure   HandleDlg  (var E: TEvent);  virtual;
     procedure   Idle; virtual;
     function    StartDialog: boolean ; virtual;
  end;


function   WinVersion  : word;
function   Mouse_Exist : boolean;
function   Get_LastKeyb  (var E : TEvent) : word;
function   Get_LastMouse (var E : TEvent) : word;

var  FigaroApp : PAppFigaro;
{--------------------------------------------------------------------}
                             implementation
{--------------------------------------------------------------------}
const
     g_Id_Mouse : word = 0;
     g_Id_Keyb  : word = 0;


var  Event_Mouse, Event_Key  : TEvent;
     g_IsMouse : boolean;
{
       ķ
                              WinVersion                        
       Ľ
                       頥  Windows
}
function WinVersion : word; assembler;
{
  AL.AH
   0.XX  -  MS-DOS  6.XX
   3.10  -  W3.1
   4.00  -  W95
}
asm
    mov  AX, 1600h
    int  2Fh
end;
{
       +---------------------------------------------------------+
       |                       Mouse_Exist                       |
       +---------------------------------------------------------+
}
function   Mouse_Exist : boolean;
begin
   Mouse_Exist:= g_IsMouse
end;
{
       +---------------------------------------------------------+
       |                       TEventsQue                        |
       +---------------------------------------------------------+
}
constructor TEventsQue.Init (Size : integer);
begin
    inherited Init (Size, 0);
end;

procedure TEventsQue.FreeItem(p: pointer);
begin
  Disable_Interrupt;
  if Assigned(p) then Dispose (PEvent(p));
  Enable_Interrupt;
end;

procedure TEventsQue.PutEvent (var E : TEvent);
var  p: PEvent;
begin
  Disable_Interrupt;
  if Count < Limit then begin
    New(p);
    Move (E, p^, SizeOf(E));
    AtInsert (Count,p);
    E.What:= evNothing
  end;
  Enable_Interrupt;
end;

procedure TEventsQue.GetEvent (var E : TEvent);
var  p: PEvent;
begin
  Disable_Interrupt;
  E.What:= evNothing;
  if Count > 0 then begin
    p:= At(0);
    E:= p^;
    Free (p);
  end;
  Enable_Interrupt;
end;
{
       +---------------------------------------------------------+
       |                        TAppFigaro                       |
       +---------------------------------------------------------+
}
procedure  Process_Mouse;    forward;
procedure  Process_Keyboard; forward;
procedure  StartAbout;       forward;

function   MouseExist: boolean; assembler;
asm
     XOR   AX,  AX
     INT   33H
end;

constructor TAppFigaro.Init;
begin
   g_IsMouse := MouseExist;
   inherited Init;
   _StartDialog:= true;
   {$IfDef Product}
      StartAbout;
   {$EndIf}
   if not StartDialog then Fail;
   if (WinVersion mod $80 <> 0) then
      MessageBox (^C'I want MS-DOS environment !'^M+
                  ^C'Now real-time clock frequency'^M+
                  ^C'set to 18.2 Hz', nil, mfOKButton);
   _QuePtr   := New(PEventsQue, Init(256));
   _EvDialog := false;
   Figaro.Init (_Regime, _Freq);

   if g_IsMouse then
   Insert_Process (New(PProcessUnlockable, Init(CNameMouse, true,
          CMinPriory+1, 0, 0, Stack(600), @Process_Mouse, nil)));
   Insert_Process (New(PProcessUnlockable, Init(CNameKeyboard, true,
          CMinPriory+2, 0, 0, Stack(600), @Process_Keyboard, nil)));

   FigaroApp:=@Self;
   _StartDialog:= false;
end;

destructor  TAppFigaro.Done;
begin
   Disable_Interrupt;
   if Assigned (_QuePtr)  then  Dispose (_QuePtr, Done);
   inherited Done;
   Figaro.Done ;
end;

procedure TAppFigaro.PutEvent (var E : TEvent);
begin
  if _StartDialog
     then inherited PutEvent(E)
     else begin
           _QuePtr^.PutEvent (E);
          end;
end;


procedure TAppFigaro.GetEvent (var E : TEvent);

function ContainsMouse(P: PView): Boolean; far;
begin
  ContainsMouse := (P^.State and sfVisible <> 0) and
                    P^.MouseInView(E.Where);
end;

begin
  if _StartDialog  then begin inherited GetEvent(E);  exit end;
  _QuePtr^.GetEvent (E);
  with E do
  if What <> evNothing
  then begin
     if StatusLine <> nil
       then if (What and evKeyDown <> 0) or
               (What and evMouseDown <> 0) and
               (FirstThat(@ContainsMouse) = PView(StatusLine))
               then  StatusLine^.HandleEvent(E)
               else if What and evIO <> 0
                       then  HandleIO (E)
                       else if (What and evDialog<> 0)
                             then if  _EvDialog
                                     then begin
                                            PutEvent(E);
                                            Exit
                                          end
                                     else begin
                                            _EvDialog:=true;
                                            HandleDlg (E);
                                          end;
  end
  else Idle;
end;

procedure TAppFigaro.Idle;
begin
   inherited Idle;
   if not _StartDialog  then  Figaro.Idle;
end;

procedure TAppFigaro.HandleIO  (var E: TEvent);
begin
  ClearEvent (E);
end;

procedure TAppFigaro.HandleDlg  (var E: TEvent);
begin
  _EvDialog:=false;
  ClearEvent (E);
end;

function   TAppFigaro.StartDialog : boolean;
begin
   _Regime   := rgPseudo;      { Pseudo-timer }
   _Freq     := 0;           { AutoDetect }
   StartDialog:= true;
end;
{
       +---------------------------------------------------------+
       |                      Process_Mouse                      |
       +---------------------------------------------------------+
}
{$F+}
procedure  Process_Mouse;
begin
  FillChar (Event_Mouse, SizeOf(Event_Mouse), 0);
  repeat
    GetMouseEvent(Event_Mouse);
    if Event_Mouse.What  <> evNothing then begin
       Inc(g_Id_Mouse);
       repeat
         Application^.PutEvent(Event_Mouse);
         if  Event_Mouse.What <> evNothing  then Wait;
       until Event_Mouse.What = evNothing;
    end;
    Wait;
  until false;
end;

function  Get_LastMouse (var E : TEvent) : word;
begin
  asm
    PUSHF
    CLI
  end;
  E:= Event_Mouse;
  Get_LastMouse:= g_Id_Mouse;
  asm POPF end;
end;
{
       +---------------------------------------------------------+
       |                      Process_Keyboard                   |
       +---------------------------------------------------------+
}
{$F+}
procedure  Process_Keyboard;
begin
  FillChar (Event_Key, SizeOf(Event_Key), 0);
  repeat
    GetKeyEvent(Event_Key);
    if Event_Key.What <> evNothing then begin
       Inc(g_Id_Keyb);
       repeat
         Application^.PutEvent(Event_Key);
         if  Event_Key.What <> evNothing  then Wait;
       until Event_Key.What = evNothing;
    end;
    Wait;
  until false;
end;

function Get_LastKeyb (var E : TEvent): word;
begin
  asm
    PUSHF
    CLI
  end;
  E:= Event_Key;
  Get_LastKeyb:= g_Id_Keyb;
  asm POPF end;
end;

procedure  StartAbout;
const
 s1: string =
  #54#164#193#216#191#228#85#209#209#37#72#50#36#190#228+
  #156#193#224#191#51#247#254#109#36#3#196#166#183#77#35+
  #8#35#136#91#161#159#238#20#243#112#117#235#22#231#194+
  #12#33#158#38#171#27#78#248#145#3#40#9#250#179#128+
  #15#123#184#42#71#182#93#227#162#12#127#174#64#150#239+
  #231#17#20#121#136#212#156#199#230#231#48#197#194#121#150+
  #68#158#41#10#225#148#41#169#149#46#92#180#94#243#23+
  #247#219#175#109#16#236#172#61#72#145#86#96#69#169#14+
  #179#204#74#34#212#74#201#38#216#236#192#41#81#121#142+
  #139#80#42#53#100#106#60#137#188#196#9#23#24#179#190;


 s2: string =
  #53#226#168#191#222#150#58#241#164#75#33#70#4#200#129+
  #238#178#137#208#93#215#204#67#20#14#199#98#115#137#231+
  #204#231#76#159#101#91#42#208#55#180#177#47#210#35#6+
  #200#229#90#226#166#24#10#157#227#102#94#108#148#214#244+
  #124#91#247#70#34#209#112#170#175#15#60#193#48#239#157+
  #142#118#124#13#168#252#255#238#198#163#85#166#226#72#175+
  #125#169#36#9#183#251#91#198#251#75#38#220#114#211#69+
  #130#168#220#4#113#225#175#109#61#243#58#9#38#137#74+
  #220#161#43#75#186#71#202#226#28#40#4#237#149#189#74+
  #79#148#238#241#160#174#248#77#120#0#205#211#220#119#122;

var R : TRect;  s : string; i : integer;
begin
  s:='';
  for i:=1 to Length(s1) do
    s:=s+chr(ord(s1[i]) xor ord(s2[i]));
  DeskTop^.GetExtent(R);
  R.Grow ((-R.B.X+36) div 2,(-R.B.Y+12) div 2);
  MessageBoxRect(R, S, nil, mfInformation+mfOKButton);
end;

end.

