(**********************************************************************
*                                                                     *
*                    ⥬  ⠡                      *
*                                                                     *
**********************************************************************)
{$O-}
                             unit  SysTabl;
                               interface

uses  Objects, Drivers, Views, Menus, TextView, Dialogs, App,
      Figaro, FigaroTV, WinProcs;

{}
type

  PListBoxSysTable =^TListBoxSysTable;
  TListBoxSysTable = object (TListBox)
     function  GetText (Item, MaxLen : integer): string; virtual;
  end;

  PDinamText   =^TDinamText;
  TDinamText   =object (TListBox)
     constructor  Init (R: TRect; ScrollBar : PScrollBar;
                        const Str : String);
     destructor   Done; virtual;
     procedure    HandleEvent (var E : TEvent); virtual;
  end;

  PWinSysTable =^TWinSysTable;
  TWinSysTable = object (TWinProcess)
     _ListBoxPtr : PListBoxSysTable;
     _CountPtr   : PStaticText;
     _Header     : PDinamText;
     constructor  Init (R : TRect );
     destructor   Done; virtual;
     function     GetPalette: PPalette ; virtual;
     procedure    NewList (CollPtr: PCollection);
     procedure    HandleEvent (var E : TEvent); virtual;
  end;

  PProcsSysTable =^TProcsSysTable;
  TProcsSysTable = object(TProcess)
        _ListPtr  : PCollection;
    procedure Stop     ; virtual;
    procedure Restart  ; virtual;
    procedure Delete   ; virtual;
  end;

  PMenuInWindow =^TMenuInWindow;
  TMenuInWindow = object(TMenuBar)
    function  GetPalette : PPalette; virtual;
  end;

const   SystemWindow : PWindow = nil;

{}
                             implementation
{}
const
       CSystemName='System Table';

const         C  = 4000;
       cmLock    = C+ 1;
       cmUnlock  = C+ 2;
       cmResume  = C+ 3;
       cmStop    = C+ 4;
       cmRestart = C+ 5;
       cmDelete  = C+ 6;
       cmUp      = C+ 7;
       cmDown    = C+ 8;
       cmLockST  = C+ 9;
       cmUnLockST= C+ 10;
       cmSelectWin=C+ 11;

       CLabel = 'Processes: ';
{
       ķ
                         Process_SysTable                       
       Ľ
}
procedure TProcsSysTable.Stop;
begin
end;

procedure TProcsSysTable.Restart;
begin
end;

procedure TProcsSysTable.Delete;
begin
  if Assigned (_ListPtr) then begin
      PCollection(_ListPtr)^.DeleteAll;
      Dispose(PCollection(_ListPtr), Done);
      _ListPtr:=nil;
  end;
  if Assigned (_ParamPtr)
     then (PWinSysTable(_ParamPtr))^.Close
     else inherited Delete
end;

{$F+}
procedure Process_SysTable;

var WinPtr : PWinSysTable;
    This   : PProcsSysTable;
    Priory : word;
begin
  Pause (CSecond div 5);
  This  := PProcsSysTable(Get_MyPtr);
  WinPtr:= PWinSysTable(Get_MyParamPtr);
  Priory:= Get_Priory('');
  repeat
    Get_SysTable(This^._ListPtr);
    if Assigned(This^._ListPtr) then
       WinPtr^.NewList(This^._ListPtr);
    Set_Priory('',Priory);
    Pause (CSecond div 2 + Random(CSecond div 4));
  until false;
end;
{$F-}
{
       ķ
                              TDinamText                        
       Ľ
}
constructor  TDinamText.Init (R: TRect; ScrollBar : PScrollBar;
                              const Str : String);
var   p: PStringCollection;
begin
   inherited Init(R, 1, nil);
   Options:=Options or ofFramed;
   GrowMode:=gfGrowHiX;
   HScrollBar:= ScrollBar;
   p:= New(PStringCollection, Init(1,0));
   p^.Insert(NewStr(Str));
   NewList (p);
end;

destructor   TDinamText.Done;
begin
  if List<> nil then begin
     Dispose (List, Done);
     List:= nil;
  end;
  inherited Done;
end;

procedure  TDinamText.HandleEvent (var E : TEvent);
begin
  with E do
   if (What=evBroadcast) and (Command=cmScrollBarChanged)
      then inherited HandleEvent(E)
end;
{
       ķ
                            TMenuInWindow                       
       Ľ
}
function  TMenuInWindow.GetPalette : PPalette;
const P : TPalette = CMenuView;
begin
   P[3]:=#6;
   P[6]:=#5;
   GetPalette:=@P;
end;
{
       ķ
                             TWinSysTable                       
       Ľ
}
constructor  TWinSysTable.Init (R : TRect );
var  p : PProcess;
     v : PView;
begin
  p:= New(PProcsSysTable, Init (CSystemName,true, 110, MaxInt, 0,
          Stack(4500),  @Process_SysTable, @Self));
  if not Assigned (p) then  Fail;
  if not Inherited Init (R,CSystemName, p) then  Fail;

  GetExtent(R);
  R.Grow(-1,-1);  R.B.Y:= R.A.Y+1;
  Insert(New (PMenuInWindow, Init(R,NewMenu(
  NewSubMenu('System_Table_~M~enu', 0, NewMenu(
    NewItem('Select',       'Alt+E', kbAltE, cmSelectWin, 0,
    NewItem('Lock',         'Alt+L', kbAltL, cmLock, 0,
    NewItem('Unlock',       'Alt+U', kbAltU, cmUnlock, 0,
    NewItem('Stop',         'Alt+S', kbAltS, cmStop, 0,
    NewItem('Restart',      'Alt+R', kbAltR, cmRestart, 0,
    NewItem('Delete',       'Alt+D', kbAltD, cmDelete, 0,
    NewLine(
    NewItem('Priory Up',    'Gray-', kbGrayMinus, cmUp, 0,
    NewItem('Priory Down',  'Gray+', kbGrayPlus, cmDown, 0,
    NewLine(
    NewItem('Lock   table', 'Ctrl+Del', kbCtrlDel, cmLockST, 0,
    NewItem('UnLock table', 'Ctrl+Ins', kbCtrlIns, cmUnLockST, 0,
     nil))))))))))))),
  nil)))));

  GetExtent(R);
  R.Grow(-1,-1); R.A.X:= R.B.X-18;  R.B.Y:= R.A.Y+1;
  _CountPtr:=New(PStaticText, Init(R, CLabel+CLabel));
  with _CountPtr^ do GrowMode:= GrowMode or gfGrowLoX or gfGrowHiX;
  Insert (_CountPtr);

  v:=StandardScrollBar(sbHandleKeyboard+sbHorizontal);

  GetExtent(R);
  R.Grow(-1,-1); R.A.Y:= R.A.Y+4;
  _ListBoxPtr :=New(PListBoxSysTable, Init(R, 1,
               StandardScrollBar(sbHandleKeyboard+sbVertical)));
  with  _ListBoxPtr^ do begin
        GrowMode:=gfGrowHiX+gfGrowHiY;
        HScrollBar:= PScrollBar(v);
        HScrollBar^.SetRange(0,40);
  end;
  Insert(_ListBoxPtr);

  GetExtent(R);
  R.Grow(-1,-1); R.A.Y:= R.A.Y+2;  R.B.Y:= R.A.Y+1;
  _Header:=New(PDinamText, Init(R, PScrollBar(v),
     'Priory     Name          Status      Time   Mail_Box    Stack_Free'));
  Insert (_Header);
  SelectNext (false);
  SystemWindow:= @Self;
end;


destructor   TWinSysTable.Done;
var p : PProcess;
begin
  if Assigned(_ListBoxPtr^.List) then _ListBoxPtr^.List^.DeleteAll;
  p:= Get_ProcessPtr(_NamePtr^);
  if Assigned(p) then  p^._ParamPtr:=nil;
  inherited Done;
  SystemWindow:=nil;
end;


procedure  TWinSysTable.NewList (CollPtr: PCollection);
var  f : integer;
     s : string;
begin
  with _ListBoxPtr^ do begin
    f:= Focused;
    List:=nil;
    NewList(CollPtr);
    if f > List^.Count-1 then f:= List^.Count-1;
    FocusItem(f);
  end;
  Str(_ListBoxPtr^.List^.Count:4, s);
  s:=CLabel+s;
  with _CountPtr^ do
  begin
    Text^:=s;
    DrawView;
  end;
end;

function    TWinSysTable.GetPalette: PPalette ;
const  P : TPalette = CDialog;
begin
   GetPalette:=@P
end;

procedure  TWinSysTable.HandleEvent (var E : TEvent);


var  p: PProcess;

procedure LocalSelect;
var   w: PWindow;
begin
  w:=PWindow(p^._ParamPtr);
  if not Assigned(w) then exit;
  w^.Select;
end;

begin
  Inherited  HandleEvent (E);
  if (E.What and evCommand) <> 0 then begin
     p:= _ListBoxPtr^.List^.At(_ListBoxPtr^.Focused);
     case E.Command of
       cmLock    : Lock_Process(p^.GetName);
       cmUnlock  : Unlock_Process(p^.GetName);
       cmResume  : Resume_Process(p^.GetName);
       cmStop    : Stop_Process(p^.GetName);
       cmRestart : Restart_Process(p^.GetName);
       cmDelete  : if p^.GetName=CSystemName
                      then Close
                      else Delete_Process(p^.GetName);
       cmDown    : Change_Priory(p^.GetName, +10);
       cmUp      : Change_Priory(p^.GetName, -10);
       cmLockST  : Lock_Process(CSystemName);
       cmUnLockST: Unlock_Process(CSystemName);
       cmSelectWin: LocalSelect;
       else        Exit;
     end;
     ClearEvent(E)
  end;
end;
{
       ķ
                          TListBoxSysTable                      
       Ľ
}
function  TListBoxSysTable.GetText (Item, MaxLen : integer): string;
var        p : PProcess;
    s, t, t1 : string;
    i        : integer;
    w        : word;
begin
  GetText:='';
  if not Assigned (List) then exit;
  p := PProcess (List^.At(Item));
  with p^ do begin
     Str (_Priory:6, t);
     s:= t+'  '+_NamePtr^;
     while Length(s) < 25 do s:=s+' ';
     System.Delete (s, 25, 255);
     case (_Status and $3) of
       stPassive: t:=' Passive';
       stRestart: t:=' Restart';
       stActive:  begin
                    if _Lock > 0 then begin
                         Str(_Lock,t);
                         t:= ' Lock ('+t+')';
                       end
                    else if _Time=0
                       then begin
                              t:=' Active';
                              case (_Status and $0C) of
                                stPassive: t:=t+'    ';
                                stPutMsg : t:=t+' '#16;
                                stGetMsg : t:=t+' '#17'';
                              end;
                            end
                       else begin
                            t:=' Suspend';
                            if _Time<0
                               then t:=t+'  Forever'
                               else begin
                                 Str(Figaro.TickToMs(_Time):9, t1);
                                 t:=t+t1;
                               end;
                       end;
                  end;
     end;
     while Length(t) < 18 do t:=t+' ';
     s:= s+t;
     if _MailBox=nil  then
        s:=s+'     -       '
     else with _MailBox^ do begin
        i:=Count;
        Str(i:5, t);
        s:=s+' '+t;
        if  i=Limit then s:=s+'  Full '
            else
        if  i=0     then s:=s+'  Empty'
            else         s:=s+'       '
     end;

  end; {with}

  w:= Get_StackFree(p);
  Str (w:8, t);

  GetText:=s+ t;
end;

end.
